#!/usr/bin/perl
 
########################################################################
# COPYRIGHT NOTICE:
#
# Copyright 2008 FocalMedia.Net All Rights Reserved.
#
# Selling the code for this program without prior written consent 
# from FocalMedia.Net is expressly forbidden. You may not 
# redistribute this program in any shape or form.
# 
# This program is distributed "as is" and without warranty of any
# kind, either express or implied. In no event shall the liability 
# of FocalMedia.Net for any damages, losses and/or causes of action 
# exceed the total amount paid by the user for this software.
#
########################################################################

#### EDIT HERE -- FOR WINDOWS/IIS BASED INSTALLATIONS ONLY #######

$config_cgi = "../config.cgi"; ## <-- CHANGE THIS LINE TO THE FULL SERVER PATH TO config.cgi

# THE PATH ON A WINDOWS INSTALLATION WILL LOOK SOMETHING LIKE THIS:
# $config_cgi = "c:/inetpub/webpub/cgi-bin/pseek/config.cgi";

#### DO NOT CHANGE ANYTHING BELOW THIS LINE #################


#use FindBin;
#use lib $FindBin::Bin;
use CGI;
use DBI;
use acs;
use obbuild;

&get_setup;
$q = CGI->new;

acs::check_access($username, $password, $q->param('username'), $q->param('password'));

##################################################################################

print "Content-type: text/html\n\n";

if ($q->param('fct') eq "") { &start; }
if ($q->param('fct') eq "save_rss") { &save_rss; }



####################################################################################

sub save_rss
{

$rss_img = $q->param('rss_img');
$mainrss = $q->param('mainrss');
$rssitems = $q->param('rssitems');
$limitnr = $q->param('limitnr');

$rss_channel_new = $q->param('rss_channel_new');
$rss_channel_title_new = $q->param('rss_channel_title_new');
$rss_channel_diz_new = $q->param('rss_channel_diz_new');

$rss_channel_pop = $q->param('rss_channel_pop');
$rss_channel_title_pop = $q->param('rss_channel_title_pop');
$rss_channel_diz_pop = $q->param('rss_channel_diz_pop');

open (RSSD, "> $data_dir/rss.conf");
	print RSSD $rss_img . "o--:--:--o";
	print RSSD $mainrss . "o--:--:--o";
	print RSSD $rssitems . "o--:--:--o";
	print RSSD $limitnr . "o--:--:--o";
	
	print RSSD $rss_channel_new . "o--:--:--o";
	print RSSD $rss_channel_title_new . "o--:--:--o";
	print RSSD $rss_channel_diz_new . "o--:--:--o";

	print RSSD $rss_channel_pop . "o--:--:--o";
	print RSSD $rss_channel_title_pop . "o--:--:--o";
	print RSSD $rss_channel_diz_pop . "o--:--:--o";
close (RSSD);


$hbox = acs::get_heading_box("$web_url/ic_rss.gif", "RSS Feed Configuration Saved", qq[
Settings Saved. <a href="$admin_url/admin71.cgi">Click here to continue.</a>
]);


print qq[
<html>
<head>
<title>RSS Feed Settings Saved</title>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css">
</head>
<body>

$hbox

</body>
</html>
];

}




sub start
{

$rssdata = acs::get_file_contents("$data_dir/rss.conf");

@rssitems = split (/o--:--:--o/, $rssdata);

$rss_img = $rssitems[0];
$mainrss = $rssitems[1];
$rssitems = $rssitems[2];
$limitnr = $rssitems[3];

$rss_channel_new = $rssitems[4];
$rss_channel_title_new = $rssitems[5];
$rss_channel_diz_new = $rssitems[6];

$rss_channel_pop = $rssitems[7];
$rss_channel_title_pop = $rssitems[8];
$rss_channel_diz_pop = $rssitems[9];


if ($limitnr eq "") { $limitnr = "50"; }

if ($rss_img eq "") { $rss_img = "$web_url/rss.gif"; }

if ($mainrss eq "") { $mainrss = qq[<?xml version="1.0" encoding="iso-8859-1" ?>
<rss version="2.0">
   <channel>
      <title>!!channel_category!!</title>
      <link>!!pagelink!!</link>
      <description>!!channel_description!!</description>
      <language>en-us</language>
      <pubDate>!!pubdate!!</pubDate>
      <lastBuildDate>!!pubdate!!</lastBuildDate>
      <generator>PowerSeek 3</generator>
      !!itemshere!!
   </channel>
</rss>
];
}

if ($rssitems eq "") { $rssitems = qq[<item>
<title>!!title!!</title>
<link>!!more_info!!</link>
<description>!!description!!</description>
<pubDate>!!pubdate!!</pubDate>
<guid>!!more_info!!</guid>
</item>
];

}




$keydata1 = &get_file_contents("$data_dir/keys.dat");
@akeys1 = split (/\n/, $keydata1);
$knr1 = @akeys1;

if ($knr1 > 0)
	{
	$kcount1 = 0;
	foreach $k_item1 (@akeys1)
		{
		($k_keyname1, $k_visible1, $k_size1, $k_searched1, $k_description1, $k_image1, $tmp, $numkey) = split (/\t/, $k_item1);
		
		if ($numkey ne "Upload")
		{
$extrakfd = $extrakfd . qq[<tr>
<td width="25%" align="right"  class="normaltext"><font color="#8080FF"><strong>!!$k_keyname1!!</strong></font></td>
<td width="75%" style="border-left: 1px solid rgb(240,240,240)"  class="normaltext">
This is an extra field/key that has been created. Add 
<strong>
!!$k_keyname1!!
</strong>
 to this template for it's values to be available.
</td>
</tr>
];
		$kcount1++;
		}
		
		}
	} 

if ($extrakfd ne "")
{
$custom_fields = qq[<table border="0" cellpadding="6" cellspacing="0" width="100%">
$extrakfd
</table>
];
}
else
{
$custom_fields = "";
}


$hbox = acs::get_heading_box("$web_url/ic_rss.gif", "RSS Feed Configuration", qq[

Configure the RSS feed configuration here to provide RSS Feeds to your visitors. The feeds available will be feeds from your categories. Note that an RSS Feed will only be available if a category contains listings. If categories does not contain listings then the RSS button will not be available as there are nothing to provide as a feed.
<BR><b>Note that to provide RSS feeds you need the variable
        !!rss!! inside the <a href="$admin_url/admin6.cgi?fct=edit_template&amp;template=defdir"
        target="_blank">'Directory Template' - defdir.html</a></b>
]);


if ($rss_channel_new eq "") { $rss_channel_new = "New Listings"; }
if ($rss_channel_title_new eq "") { $rss_channel_title_new = "New Listings"; }
if ($rss_channel_diz_new eq "") { $rss_channel_diz_new = "New Listings"; }

if ($rss_channel_pop eq "") { $rss_channel_pop = "Popular Listings"; }
if ($rss_channel_title_pop eq "") { $rss_channel_title_pop = "Popular Listings"; }
if ($rss_channel_diz_pop eq "") { $rss_channel_diz_pop = "Popular Listings"; }


print qq[
<html>
<head>
<title>PowerSeek</title>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css">
</head>
<body>

$hbox


<form method="POST" action="$admin_url/admin71.cgi">
  <input type="hidden" name="fct" value="save_rss"><table border="0" cellspacing="1"
  width="100%" cellpadding="6" bgcolor="#DDDDDD">
    <tr>
      <td width="100%" height="30" colspan="2" background="$web_url/bar6.gif" class="normaltext"><strong>RSS
      Feed Configuration:</strong></td>
    </tr>
    <tr>
      <td width="21%" height="30" bgcolor="#FFFFFF" class="normaltext"><strong>RSS Image to use:
      </strong></td>
      <td width="79%" height="30" bgcolor="#FFFFFF" class="normaltext"><strong><input
      type="text" name="rss_img" size="67" value="$rss_img"> </strong></td>
    </tr>
    <tr>
      <td width="21%" height="30" valign="top" bgcolor="#FFFFFF" class="normaltext"><strong>RSS
      Main Template: <br>
      </strong>This template will be used for the main part of the RSS Feed. It will define the
      &lt;channel&gt; elements. </td>
      <td width="79%" height="30" bgcolor="#FFFFFF" class="normaltext"><strong><textarea
      rows="10" name="mainrss" cols="66">$mainrss</textarea> </strong><p><strong>Note that
      !!itemshere!! is a special variable where the &lt;item&gt; elements are inserted by
      PowerSeek. It has to be present in this template. </strong></p>
      <p><strong>Variables available in this template: </strong></p>
      <table border="0" cellpadding="6" cellspacing="0" width="100%">
        <tr>
          <td width="26%" align="right" class="normaltext"><strong>!!channel_category!! </strong></td>
          <td width="74%" class="normaltext" style="border-left: 1px solid rgb(240,240,240)">Replaced
          by the Category Name of the current category </td>
        </tr>
        <tr>
          <td width="26%" align="right" class="normaltext"><strong>!!channel_title!! </strong></td>
          <td width="74%" class="normaltext" style="border-left: 1px solid rgb(240,240,240)">Replaced
          by the title of a category. Titles can be added to categories when adding/editing
          categories. If a category does not have a channel title then the category name will be
          used. </td>
        </tr>
        <tr>
          <td width="26%" align="right" class="normaltext"><strong>!!channel_description!! </strong></td>
          <td width="74%" class="normaltext" style="border-left: 1px solid rgb(240,240,240)">Replaced
          by the description of the current category. Descriptions of categories can be added when
          adding/editing categories. </td>
        </tr>
        <tr>
          <td width="26%" align="right" class="normaltext"><strong>!!pubdate!! </strong></td>
          <td width="74%" class="normaltext" style="border-left: 1px solid rgb(240,240,240)">The
          update date of the category. When new links was added for example. </td>
        </tr>
        <tr>
          <td width="26%" align="right" class="normaltext"><strong>!!pagelink!! </strong></td>
          <td width="74%" class="normaltext" style="border-left: 1px solid rgb(240,240,240)">The URL
          to the page from which the RSS feed was obtained. </td>
        </tr>
      </table>
      </td>
    </tr>
    <tr>
      <td width="21%" height="30" valign="top" bgcolor="#FFFFFF" class="normaltext"><strong>RSS
      Item Template: </strong><br>
      This template will be used to indicate listings. It will define the &lt;item&gt; elements.
      </td>
      <td width="79%" height="30" bgcolor="#FFFFFF" class="normaltext"><strong><textarea
      rows="10" name="rssitems" cols="63">$rssitems</textarea> </strong><p><strong>Variables
      available in this template: </strong></p>
      <table border="0" cellpadding="6" cellspacing="0" width="100%">
        <tr>
          <td width="25%" align="right" class="normaltext"><strong>!!title!! </strong></td>
          <td width="75%" class="normaltext" style="border-left: 1px solid rgb(240,240,240)">Title
          of a listing. </td>
        </tr>
        <tr>
          <td width="25%" align="right" class="normaltext"><strong>!!description!! </strong></td>
          <td width="75%" class="normaltext" style="border-left: 1px solid rgb(240,240,240)">Description
          of a listing. </td>
        </tr>
        <tr>
          <td width="25%" align="right" class="normaltext"><strong>!!url!! </strong></td>
          <td width="75%" class="normaltext" style="border-left: 1px solid rgb(240,240,240)">URL of
          the listing. </td>
        </tr>
        <tr>
          <td width="25%" align="right" class="normaltext"><strong>!!more_info!! </strong></td>
          <td width="75%" class="normaltext" style="border-left: 1px solid rgb(240,240,240)">'More
          Info' URL of listing. </td>
        </tr>
        <tr>
          <td width="25%" align="right" class="normaltext"><strong>!!pubdate!! </strong></td>
          <td width="75%" class="normaltext" style="border-left: 1px solid rgb(240,240,240)">The
          date the listing was added. </td>
        </tr>
        <tr>
          <td width="25%" align="right" class="normaltext"><strong>!!name!! </strong></td>
          <td width="75%" class="normaltext" style="border-left: 1px solid rgb(240,240,240)">Owner
          name of listing owner. </td>
        </tr>
        <tr>
          <td width="25%" align="right" class="normaltext"><strong>!!email!! </strong></td>
          <td width="75%" class="normaltext" style="border-left: 1px solid rgb(240,240,240)">Email
          address of listing owner. </td>
        </tr>
      </table>
      <p><strong>$custom_fields </strong></td>
    </tr>
    <tr>
      <td width="21%" height="30" valign="top" bgcolor="#FFFFFF" class="normaltext"><strong>Number
      of Listings to Limit: </strong></td>
      <td width="79%" height="30" bgcolor="#FFFFFF" class="normaltext"><strong><input
      type="text" name="limitnr" size="5" value="$limitnr"> <br>
      </strong>Specify 0 (zero) to display an unlimited number of listings with the feed.
      (Recommended 50) - The reason this option exists is because categories with hundreds or
      thousands of links can cause lockups or very slow loads of the feeds because that amount
      of links would take very long to load. </td>
    </tr>
  </table>
  <table border="0" cellpadding="0" cellspacing="0" width="100%"
  background="$web_url/shadow.gif">
    <tr>
      <td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_</font> </td>
      <td width="99%"></td>
    </tr>
  </table>
  <table border="0" cellspacing="1" width="100%" cellpadding="6" bgcolor="#DDDDDD"
  height="149">
    <tr>
      <td width="100%" height="21" colspan="2" background="$web_url/bar6.gif" class="normaltext"><strong>RSS
      Feed Configuration for What's New Listings:</strong></td>
    </tr>
    <tr>
      <td width="21%" height="25" bgcolor="#FFFFFF" class="normaltext"><strong>Channel Category</strong></td>
      <td width="79%" height="25" bgcolor="#FFFFFF" class="normaltext"><strong><input
      type="text" name="rss_channel_new" size="67" value="$rss_channel_new"> </strong></td>
    </tr>
    <tr>
      <td width="21%" height="25" bgcolor="#FFFFFF" class="normaltext"><strong>Channel Title:</strong></td>
      <td width="79%" height="25" bgcolor="#FFFFFF" class="normaltext"><strong><input
      type="text" name="rss_channel_title_new" size="67" value="$rss_channel_title_new"></strong></td>
    </tr>
    <tr>
      <td width="21%" height="22" bgcolor="#FFFFFF" class="normaltext"><strong>Channel
      Description:</strong></td>
      <td width="79%" height="22" bgcolor="#FFFFFF" class="normaltext"><strong><input
      type="text" name="rss_channel_diz_new" size="67" value="$rss_channel_diz_new"></strong></td>
    </tr>
  </table>
  <table border="0" cellpadding="0" cellspacing="0" width="100%"
  background="$web_url/shadow.gif">
    <tr>
      <td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_</font> </td>
      <td width="99%"></td>
    </tr>
  </table>
  <table border="0" cellspacing="1" width="100%" cellpadding="6" bgcolor="#DDDDDD">
    <tr>
      <td width="100%" height="30" colspan="2" background="$web_url/bar6.gif" class="normaltext"><strong>RSS
      Feed Configuration for Popular Listings:</strong></td>
    </tr>
    <tr>
      <td width="21%" height="30" bgcolor="#FFFFFF" class="normaltext"><strong>Channel Category</strong></td>
      <td width="79%" height="30" bgcolor="#FFFFFF" class="normaltext"><strong><input
      type="text" name="rss_channel_pop" size="67" value="$rss_channel_pop"> </strong></td>
    </tr>
    <tr>
      <td width="21%" height="30" bgcolor="#FFFFFF" class="normaltext"><strong>Channel Title:</strong></td>
      <td width="79%" height="30" bgcolor="#FFFFFF" class="normaltext"><strong><input
      type="text" name="rss_channel_title_new" size="67" value="$rss_channel_title_pop"></strong></td>
    </tr>
    <tr>
      <td width="21%" height="30" bgcolor="#FFFFFF" class="normaltext"><strong>Channel
      Description:</strong></td>
      <td width="79%" height="30" bgcolor="#FFFFFF" class="normaltext"><strong><input
      type="text" name="rss_channel_diz_new" size="67" value="$rss_channel_diz_pop"></strong></td>
    </tr>
  </table>
  <table border="0" cellpadding="0" cellspacing="0" width="100%"
  background="$web_url/shadow.gif">
    <tr>
      <td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_</font> </td>
      <td width="99%"></td>
    </tr>
  </table>
  <table border="0" cellspacing="1" width="100%" cellpadding="6" bgcolor="#DDDDDD">
    <tr>
      <td width="21%" height="30" bgcolor="#FFFFFF" class="normaltext"></td>
      <td width="79%" height="30" bgcolor="#FFFFFF" class="normaltext"><input type="submit"
      value="   Save RSS Configuration   " name="B1"> </td>
    </tr>
  </table>
  <table border="0" cellpadding="0" cellspacing="0" width="100%"
  background="$web_url/shadow.gif">
    <tr>
      <td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_</font> </td>
      <td width="99%"></td>
    </tr>
  </table>
</form>

</body>
</html>

];




}



sub get_setup
{

$exists = (-e "$config_cgi");
if ($exists > 0)
	{
	open (STP, "$config_cgi");
		while (defined($line=<STP>))
			{
			if ($line =~ m/#/g)
				{
				$r = pos($line);
				$line = substr($line, 0, $r - 1);
				}
				
				$line =~ s/\n//g;
	
if ($line =~ /^DB_NAME/){$db_name = &get_setup_line($line, DB_NAME);}
if ($line =~ /^DB_USERNAME/){$db_username = &get_setup_line($line, DB_USERNAME);}
if ($line =~ /^DB_PASSWORD/){$db_password = &get_setup_line($line, DB_PASSWORD);}
if ($line =~ /^MYSQL_HOSTNAME/){$mysql_hostname = &get_setup_line($line, MYSQL_HOSTNAME);}
if ($line =~ /^MYSQL_PORT/){$mysql_port = &get_setup_line($line, MYSQL_PORT);}

if ($line =~ /^SCRIPT_URL/){$script_url = &get_setup_line($line, SCRIPT_URL);}
if ($line =~ /^ADMIN_URL/){$admin_url = &get_setup_line($line, ADMIN_URL);}
if ($line =~ /^WEB_URL/){$web_url = &get_setup_line($line, WEB_URL);}
if ($line =~ /^WEB_DIR/){$web_dir = &get_setup_line($line, WEB_DIR);}
if ($line =~ /^DATA_DIR/){$data_dir = &get_setup_line($line, DATA_DIR);}

if ($line =~ /^USERNAME/){$username = &get_setup_line($line, USERNAME);}
if ($line =~ /^PASSWORD/){$password = &get_setup_line($line, PASSWORD);}


			}
	close (STP);
	
	}
}




sub get_setup_line
{
my ($setup_line, $setup_var) = @_;
$crit = "\"";
$setup_line =~ m/$crit/g;
$r1 = pos($setup_line);
$setup_line =~ m/$crit/g;
$r2 = pos($setup_line);
$setup_line = substr($setup_line, $r1, ($r2 - $r1 - 1));
$return_val = $setup_line;
return ($return_val);
}

#### END CONFIGURATION ########################################################

